import { __read, __spread, __values } from "tslib";
export default (function (response, key) {
    var e_1, _a;
    var identifier = response[key];
    if (!response._embedded) {
        throw new Error('No embedded data in response');
    }
    if (response._embedded[key]) {
        if (!Array.isArray(identifier)) {
            return response._embedded[key].find(function (record) { return record.id === identifier; });
        }
        else {
            return identifier.map(function (identifier) { return response._embedded[key].find(function (record) { return record.id === identifier; }); })
                .filter(function (v) { return !!v; });
        }
    }
    var featuredMedia = response._embedded["wp:" + key.split('_').join('')];
    if (featuredMedia) {
        if (!Array.isArray(identifier)) {
            return featuredMedia.find(function (record) { return record.id === identifier; });
        }
        else {
            return identifier.map(function (identifier) { return featuredMedia.find(function (record) { return record.id === identifier; }); })
                .filter(function (v) { return !!v; });
        }
    }
    // Try to find in wp:term
    var wpTerms = response._embedded['wp:term'];
    if (wpTerms) {
        var matchingResults = [];
        var containsIds_1 = function (id) {
            if (Array.isArray(identifier)) {
                return identifier.some(function (identifier) { return identifier === id; });
            }
            else {
                return identifier === id;
            }
        };
        try {
            for (var wpTerms_1 = __values(wpTerms), wpTerms_1_1 = wpTerms_1.next(); !wpTerms_1_1.done; wpTerms_1_1 = wpTerms_1.next()) {
                var wpTerm = wpTerms_1_1.value;
                var localMatches = wpTerm.filter(function (term) {
                    return term
                        && term.taxonomy === key
                        && containsIds_1(term.id);
                });
                if (localMatches && !!localMatches.length) {
                    matchingResults.push.apply(matchingResults, __spread(localMatches));
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (wpTerms_1_1 && !wpTerms_1_1.done && (_a = wpTerms_1.return)) _a.call(wpTerms_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return matchingResults;
    }
    throw new Error('Could not find corresponding field');
});
//# sourceMappingURL=FindCorrespondingEmbed.js.map